// $ANTLR : "SE-02.06.00.00.00-TAnf-2.1 [TAnf IBV].g" -> "UDAParser.java"$

	package de.bsvrz.ibv.uda.parser;
	import java.io.*;
	import java.awt.event.*;
	import antlr.*;
	import antlr.debug.misc.*;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

public class UDAParser extends antlr.LLkParser       implements UDATokensTokenTypes
 {

	public static void main(String[] args) {
		UDAParser parser;
		UDALexer lexer;

		try {
			if(args.length!=1) {
				System.err.println("usage: java UDAParser");
			}
			else {
				// open a simple stream to the input
				DataInputStream input = new DataInputStream(new FileInputStream(args[0]));

				// attach uda lexer to the input stream,
				lexer = new UDALexer(input);


				// Create parser attached to lexer
				parser = new UDAParser(lexer);
				parser.setASTNodeClass(CommonASTWithLines.class.getName());
//				parser.setFilename(args[0]);

				// Start up the parser by calling the rule
				// at which you want to begin parsing.
				parser.skript();

				// Get the tree out of the parser
				CommonASTWithLines t = (CommonASTWithLines) parser.getAST();

				//System.out.println(t.toStringList());
				((CommonAST)t).setVerboseStringConversion(true,parser.getTokenNames());
				ASTFactory factory= new ASTFactory();
				AST r= factory.create(0,"AST ROOT");
				r.setFirstChild(t);
				final ASTFrame frame = new ASTFrame("UDA AST", r);
				frame.setVisible(true);
				frame.addWindowListener(
					new WindowAdapter() {
					   public void windowClosing (WindowEvent e) {
						   frame.setVisible(false); // hide the Frame
						   frame.dispose();
						   System.exit(0);
					   }
					}
				);

			}
		}
		catch(Exception e) {
			System.err.println("exception: "+e);
			e.printStackTrace(System.err);	 // so we can get stack trace
		}
	}

protected UDAParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public UDAParser(TokenBuffer tokenBuf) {
  this(tokenBuf,3);
}

protected UDAParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public UDAParser(TokenStream lexer) {
  this(lexer,3);
}

public UDAParser(ParserSharedInputState state) {
  super(state,3);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

	public final void skript() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST skript_AST = null;
		
		try {      // for error handling
			{
			int _cnt3=0;
			_loop3:
			do {
				switch ( LA(1)) {
				case ZeilenEnde:
				case Ausgabe:
				case Debug:
				case Benutze:
				case Ausnahme:
				case Mit:
				case Ohne:
				case Name:
				case KlammerAuf:
				case Versuche:
				case Iteration:
				case Zyklisch:
				case Wenn:
				case Anmeldung:
				case Rueckgabe:
				case Rueckgabe2:
				{
					anweisungsZeile();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case Funktion:
				case Quantor:
				{
					funktionsDefinitionsBlock();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				default:
				{
					if ( _cnt3>=1 ) { break _loop3; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				}
				_cnt3++;
			} while (true);
			}
			match(Token.EOF_TYPE);
			skript_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_0);
			} else {
			  throw ex;
			}
		}
		returnAST = skript_AST;
	}
	
	public final void anweisungsZeile() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anweisungsZeile_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case Ausgabe:
			case Debug:
			case Benutze:
			case Ausnahme:
			case Mit:
			case Ohne:
			case Name:
			case KlammerAuf:
			case Versuche:
			case Iteration:
			case Zyklisch:
			case Wenn:
			case Anmeldung:
			case Rueckgabe:
			case Rueckgabe2:
			{
				anweisung();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case ZeilenEnde:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(ZeilenEnde);
			anweisungsZeile_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		returnAST = anweisungsZeile_AST;
	}
	
	public final void funktionsDefinitionsBlock() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST funktionsDefinitionsBlock_AST = null;
		
		try {      // for error handling
			funktionsDefinition();
			astFactory.addASTChild(currentAST, returnAST);
			match(ZeilenEnde);
			funktionsDefinitionsBlock_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		returnAST = funktionsDefinitionsBlock_AST;
	}
	
	public final void anweisungsZeilen() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anweisungsZeilen_AST = null;
		
		try {      // for error handling
			{
			_loop6:
			do {
				if ((_tokenSet_3.member(LA(1)))) {
					anweisungsZeile();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop6;
				}
				
			} while (true);
			}
			anweisungsZeilen_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_4);
			} else {
			  throw ex;
			}
		}
		returnAST = anweisungsZeilen_AST;
	}
	
	public final void anweisung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anweisung_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Ausgabe:
			case Debug:
			{
				ausgabeAnweisung();
				astFactory.addASTChild(currentAST, returnAST);
				anweisung_AST = (AST)currentAST.root;
				break;
			}
			case Benutze:
			{
				benutzeAnweisung();
				astFactory.addASTChild(currentAST, returnAST);
				anweisung_AST = (AST)currentAST.root;
				break;
			}
			case Iteration:
			{
				iterationsAnweisung();
				astFactory.addASTChild(currentAST, returnAST);
				anweisung_AST = (AST)currentAST.root;
				break;
			}
			case Wenn:
			{
				wennAnweisung();
				astFactory.addASTChild(currentAST, returnAST);
				anweisung_AST = (AST)currentAST.root;
				break;
			}
			case Rueckgabe:
			case Rueckgabe2:
			{
				rueckgabeAnweisung();
				astFactory.addASTChild(currentAST, returnAST);
				anweisung_AST = (AST)currentAST.root;
				break;
			}
			case Mit:
			case Ohne:
			{
				fehlerPruefungsAnweisung();
				astFactory.addASTChild(currentAST, returnAST);
				anweisung_AST = (AST)currentAST.root;
				break;
			}
			case Name:
			case KlammerAuf:
			{
				zuweisungsAnweisung();
				astFactory.addASTChild(currentAST, returnAST);
				anweisung_AST = (AST)currentAST.root;
				break;
			}
			case Zyklisch:
			{
				zyklischAnweisung();
				astFactory.addASTChild(currentAST, returnAST);
				anweisung_AST = (AST)currentAST.root;
				break;
			}
			case Anmeldung:
			{
				anmeldungsAnweisung();
				astFactory.addASTChild(currentAST, returnAST);
				anweisung_AST = (AST)currentAST.root;
				break;
			}
			case Versuche:
			{
				versucheAnweisung();
				astFactory.addASTChild(currentAST, returnAST);
				anweisung_AST = (AST)currentAST.root;
				break;
			}
			case Ausnahme:
			{
				ausnahmeAnweisung();
				astFactory.addASTChild(currentAST, returnAST);
				anweisung_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = anweisung_AST;
	}
	
	public final void ausgabeAnweisung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST ausgabeAnweisung_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Ausgabe:
			{
				AST tmp4_AST = null;
				tmp4_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp4_AST);
				match(Ausgabe);
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				ausgabeAnweisung_AST = (AST)currentAST.root;
				break;
			}
			case Debug:
			{
				AST tmp5_AST = null;
				tmp5_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp5_AST);
				match(Debug);
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				ausgabeAnweisung_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = ausgabeAnweisung_AST;
	}
	
	public final void benutzeAnweisung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST benutzeAnweisung_AST = null;
		
		try {      // for error handling
			AST tmp6_AST = null;
			tmp6_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp6_AST);
			match(Benutze);
			AST tmp7_AST = null;
			tmp7_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp7_AST);
			match(Zeichenkette);
			benutzeAnweisung_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = benutzeAnweisung_AST;
	}
	
	public final void iterationsAnweisung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST iterationsAnweisung_AST = null;
		
		try {      // for error handling
			AST tmp8_AST = null;
			tmp8_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp8_AST);
			match(Iteration);
			iterationsKopf();
			astFactory.addASTChild(currentAST, returnAST);
			match(ZeilenEnde);
			anweisungsZeilen();
			astFactory.addASTChild(currentAST, returnAST);
			match(Ende);
			match(Iteration);
			iterationsAnweisung_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = iterationsAnweisung_AST;
	}
	
	public final void wennAnweisung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST wennAnweisung_AST = null;
		
		try {      // for error handling
			AST tmp12_AST = null;
			tmp12_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp12_AST);
			match(Wenn);
			ausdruck();
			astFactory.addASTChild(currentAST, returnAST);
			{
			if ((LA(1)==Dann) && (LA(2)==ZeilenEnde)) {
				wennAnweisungsDannTeil();
				astFactory.addASTChild(currentAST, returnAST);
				wennAnweisungsAlternativen();
				astFactory.addASTChild(currentAST, returnAST);
				{
				switch ( LA(1)) {
				case Sonst:
				{
					wennAnweisungsDefault();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case Ende:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(Ende);
				match(Wenn);
			}
			else if ((LA(1)==Dann) && (_tokenSet_6.member(LA(2)))) {
				wennAnweisungsKurzformDannTeil();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			wennAnweisung_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = wennAnweisung_AST;
	}
	
	public final void rueckgabeAnweisung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST rueckgabeAnweisung_AST = null;
		
		try {      // for error handling
			rueckgabe();
			astFactory.addASTChild(currentAST, returnAST);
			ausdruck();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				rueckgabeAnweisung_AST = (AST)currentAST.root;
				rueckgabeAnweisung_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(RUECKGABEANWEISUNG,"RUECKGABEANWEISUNG")).add(rueckgabeAnweisung_AST));
				currentAST.root = rueckgabeAnweisung_AST;
				currentAST.child = rueckgabeAnweisung_AST!=null &&rueckgabeAnweisung_AST.getFirstChild()!=null ?
					rueckgabeAnweisung_AST.getFirstChild() : rueckgabeAnweisung_AST;
				currentAST.advanceChildToEnd();
			}
			rueckgabeAnweisung_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = rueckgabeAnweisung_AST;
	}
	
	public final void fehlerPruefungsAnweisung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST fehlerPruefungsAnweisung_AST = null;
		
		try {      // for error handling
			if ((LA(1)==Mit) && (LA(2)==Fehlerausgabe)) {
				AST tmp15_AST = null;
				tmp15_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp15_AST);
				match(Mit);
				AST tmp16_AST = null;
				tmp16_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp16_AST);
				match(Fehlerausgabe);
				erweiterterAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				fehlerPruefungsAnweisung_AST = (AST)currentAST.root;
			}
			else if ((LA(1)==Mit) && (LA(2)==Fehlerrueckgabe)) {
				AST tmp17_AST = null;
				tmp17_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp17_AST);
				match(Mit);
				AST tmp18_AST = null;
				tmp18_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp18_AST);
				match(Fehlerrueckgabe);
				erweiterterAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				fehlerPruefungsAnweisung_AST = (AST)currentAST.root;
			}
			else if ((LA(1)==Mit) && (LA(2)==Fehlerrueckgabe2)) {
				AST tmp19_AST = null;
				tmp19_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp19_AST);
				match(Mit);
				AST tmp20_AST = null;
				tmp20_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp20_AST);
				match(Fehlerrueckgabe2);
				erweiterterAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				fehlerPruefungsAnweisung_AST = (AST)currentAST.root;
			}
			else if ((LA(1)==Ohne) && (LA(2)==Fehlerpruefung)) {
				AST tmp21_AST = null;
				tmp21_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp21_AST);
				match(Ohne);
				AST tmp22_AST = null;
				tmp22_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp22_AST);
				match(Fehlerpruefung);
				erweiterterAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				fehlerPruefungsAnweisung_AST = (AST)currentAST.root;
			}
			else if ((LA(1)==Ohne) && (LA(2)==Fehlerpruefung2)) {
				AST tmp23_AST = null;
				tmp23_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp23_AST);
				match(Ohne);
				AST tmp24_AST = null;
				tmp24_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp24_AST);
				match(Fehlerpruefung2);
				erweiterterAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				fehlerPruefungsAnweisung_AST = (AST)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = fehlerPruefungsAnweisung_AST;
	}
	
	public final void zuweisungsAnweisung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST zuweisungsAnweisung_AST = null;
		
		try {      // for error handling
			linksSeitigerAusdruck();
			astFactory.addASTChild(currentAST, returnAST);
			match(Gleich);
			ausdruck();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				zuweisungsAnweisung_AST = (AST)currentAST.root;
				zuweisungsAnweisung_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(ZUWEISUNG,"ZUWEISUNG")).add(zuweisungsAnweisung_AST));
				currentAST.root = zuweisungsAnweisung_AST;
				currentAST.child = zuweisungsAnweisung_AST!=null &&zuweisungsAnweisung_AST.getFirstChild()!=null ?
					zuweisungsAnweisung_AST.getFirstChild() : zuweisungsAnweisung_AST;
				currentAST.advanceChildToEnd();
			}
			zuweisungsAnweisung_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = zuweisungsAnweisung_AST;
	}
	
	public final void zyklischAnweisung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST zyklischAnweisung_AST = null;
		
		try {      // for error handling
			AST tmp26_AST = null;
			tmp26_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp26_AST);
			match(Zyklisch);
			zyklischKopf();
			astFactory.addASTChild(currentAST, returnAST);
			anweisungsZeilen();
			astFactory.addASTChild(currentAST, returnAST);
			match(Ende);
			match(Zyklisch);
			zyklischAnweisung_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = zyklischAnweisung_AST;
	}
	
	public final void anmeldungsAnweisung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anmeldungsAnweisung_AST = null;
		
		try {      // for error handling
			AST tmp29_AST = null;
			tmp29_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp29_AST);
			match(Anmeldung);
			AST tmp30_AST = null;
			tmp30_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp30_AST);
			match(Name);
			{
			int _cnt106=0;
			_loop106:
			do {
				if ((LA(1)==ZeilenEnde)) {
					match(ZeilenEnde);
				}
				else {
					if ( _cnt106>=1 ) { break _loop106; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt106++;
			} while (true);
			}
			{
			switch ( LA(1)) {
			case Definition:
			{
				anmeldungDefinition();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case Ende:
			case Quelle:
			case Sender:
			case Senke:
			case Fehlerbehandlung:
			case Initial:
			case Jeweils:
			case Empfaenger:
			case Empfaenger2:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case Quelle:
			{
				anmeldungQuelle();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case Ende:
			case Sender:
			case Senke:
			case Fehlerbehandlung:
			case Initial:
			case Jeweils:
			case Empfaenger:
			case Empfaenger2:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case Sender:
			{
				anmeldungSender();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case Ende:
			case Senke:
			case Fehlerbehandlung:
			case Initial:
			case Jeweils:
			case Empfaenger:
			case Empfaenger2:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case Senke:
			{
				anmeldungSenke();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case Ende:
			case Fehlerbehandlung:
			case Initial:
			case Jeweils:
			case Empfaenger:
			case Empfaenger2:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case Empfaenger:
			case Empfaenger2:
			{
				anmeldungEmpfaenger();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case Ende:
			case Fehlerbehandlung:
			case Initial:
			case Jeweils:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case Fehlerbehandlung:
			{
				fehlerBehandlungsBlock();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case Ende:
			case Initial:
			case Jeweils:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case Initial:
			{
				anmeldungInitial();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case Ende:
			case Jeweils:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			if ((LA(1)==Jeweils) && (LA(2)==Bei) && (LA(3)==Aktualisierung)) {
				anmeldungAktualisierung();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else if ((LA(1)==Ende||LA(1)==Jeweils) && (LA(2)==Anmeldung||LA(2)==Bei) && (LA(3)==ZeilenEnde||LA(3)==MengenAenderung||LA(3)==MengenAenderung2)) {
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			{
			switch ( LA(1)) {
			case Jeweils:
			{
				anmeldungMengenAenderung();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case Ende:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(Ende);
			match(Anmeldung);
			anmeldungsAnweisung_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = anmeldungsAnweisung_AST;
	}
	
	public final void versucheAnweisung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST versucheAnweisung_AST = null;
		
		try {      // for error handling
			AST tmp34_AST = null;
			tmp34_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp34_AST);
			match(Versuche);
			match(ZeilenEnde);
			anweisungsZeilen();
			astFactory.addASTChild(currentAST, returnAST);
			fehlerBehandlungsBlock();
			astFactory.addASTChild(currentAST, returnAST);
			match(Ende);
			match(Versuche);
			versucheAnweisung_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = versucheAnweisung_AST;
	}
	
	public final void ausnahmeAnweisung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST ausnahmeAnweisung_AST = null;
		
		try {      // for error handling
			AST tmp38_AST = null;
			tmp38_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp38_AST);
			match(Ausnahme);
			ausdruck();
			astFactory.addASTChild(currentAST, returnAST);
			ausnahmeAnweisung_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = ausnahmeAnweisung_AST;
	}
	
	public final void ausdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST ausdruck_AST = null;
		
		try {      // for error handling
			quantorAusdruck();
			astFactory.addASTChild(currentAST, returnAST);
			ausdruck_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = ausdruck_AST;
	}
	
	public final void rueckgabe() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST rueckgabe_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Rueckgabe:
			{
				match(Rueckgabe);
				rueckgabe_AST = (AST)currentAST.root;
				break;
			}
			case Rueckgabe2:
			{
				match(Rueckgabe2);
				rueckgabe_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		returnAST = rueckgabe_AST;
	}
	
	public final void linksSeitigerAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST linksSeitigerAusdruck_AST = null;
		
		try {      // for error handling
			linksSeitigerBasisAusdruck();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop83:
			do {
				switch ( LA(1)) {
				case Punkt:
				{
					AST tmp41_AST = null;
					tmp41_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp41_AST);
					match(Punkt);
					AST tmp42_AST = null;
					tmp42_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp42_AST);
					match(Name);
					break;
				}
				case EckigeKlammerAuf:
				{
					AST tmp43_AST = null;
					tmp43_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp43_AST);
					match(EckigeKlammerAuf);
					{
					if ((_tokenSet_8.member(LA(1))) && (_tokenSet_9.member(LA(2)))) {
						ausdruck();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else if ((LA(1)==Name) && (LA(2)==Doppelpunkt)) {
						AST tmp44_AST = null;
						tmp44_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp44_AST);
						match(Name);
						match(Doppelpunkt);
						ausdruck();
						astFactory.addASTChild(currentAST, returnAST);
						{
						_loop82:
						do {
							if ((LA(1)==Komma)) {
								AST tmp46_AST = null;
								tmp46_AST = astFactory.create(LT(1));
								astFactory.addASTChild(currentAST, tmp46_AST);
								match(Komma);
								AST tmp47_AST = null;
								tmp47_AST = astFactory.create(LT(1));
								astFactory.addASTChild(currentAST, tmp47_AST);
								match(Name);
								match(Doppelpunkt);
								ausdruck();
								astFactory.addASTChild(currentAST, returnAST);
							}
							else {
								break _loop82;
							}
							
						} while (true);
						}
					}
					else {
						throw new NoViableAltException(LT(1), getFilename());
					}
					
					}
					match(EckigeKlammerZu);
					break;
				}
				default:
				{
					break _loop83;
				}
				}
			} while (true);
			}
			linksSeitigerAusdruck_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		returnAST = linksSeitigerAusdruck_AST;
	}
	
	public final void erweiterterAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST erweiterterAusdruck_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Zeichenkette:
			case Zahl:
			case Aktuell:
			case Undefiniert:
			case Falsch:
			case Wahr:
			{
				basisAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				erweiterterAusdruck_AST = (AST)currentAST.root;
				break;
			}
			case Name:
			case EckigeKlammerAuf:
			case GeschweifteKlammerAuf:
			case KlammerAuf:
			{
				erweiterbarerBasisAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop54:
				do {
					switch ( LA(1)) {
					case Punkt:
					{
						AST tmp50_AST = null;
						tmp50_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp50_AST);
						match(Punkt);
						attributOderMethodenaufruf();
						astFactory.addASTChild(currentAST, returnAST);
						break;
					}
					case EckigeKlammerAuf:
					{
						AST tmp51_AST = null;
						tmp51_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp51_AST);
						match(EckigeKlammerAuf);
						{
						if ((_tokenSet_8.member(LA(1))) && (_tokenSet_9.member(LA(2)))) {
							ausdruck();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else if ((LA(1)==Name) && (LA(2)==Doppelpunkt)) {
							selektorAusdruck();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else {
							throw new NoViableAltException(LT(1), getFilename());
						}
						
						}
						match(EckigeKlammerZu);
						break;
					}
					case GeschweifteKlammerAuf:
					{
						AST tmp53_AST = null;
						tmp53_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp53_AST);
						match(GeschweifteKlammerAuf);
						selektorAusdruck();
						astFactory.addASTChild(currentAST, returnAST);
						match(GeschweifteKlammerZu);
						break;
					}
					default:
					{
						break _loop54;
					}
					}
				} while (true);
				}
				erweiterterAusdruck_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_11);
			} else {
			  throw ex;
			}
		}
		returnAST = erweiterterAusdruck_AST;
	}
	
	public final void quantorAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST quantorAusdruck_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Fuer:
			case Fuer2:
			{
				fuer();
				quantor();
				astFactory.addASTChild(currentAST, returnAST);
				{
				switch ( LA(1)) {
				case Der:
				{
					match(Der);
					{
					switch ( LA(1)) {
					case Elemente:
					{
						match(Elemente);
						break;
					}
					case Name:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					break;
				}
				case Name:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				AST tmp57_AST = null;
				tmp57_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp57_AST);
				match(Name);
				match(In);
				{
				switch ( LA(1)) {
				case Der:
				case Dem:
				case Den:
				{
					dem();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case Zeichenkette:
				case Name:
				case Minus:
				case Nicht:
				case EckigeKlammerAuf:
				case GeschweifteKlammerAuf:
				case Zahl:
				case Aktuell:
				case Undefiniert:
				case KlammerAuf:
				case Fuer:
				case Fuer2:
				case Falsch:
				case Wahr:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				bedingungsTeil();
				astFactory.addASTChild(currentAST, returnAST);
				if ( inputState.guessing==0 ) {
					quantorAusdruck_AST = (AST)currentAST.root;
					quantorAusdruck_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(QUANTOR,"QUANTOR")).add(quantorAusdruck_AST));
					currentAST.root = quantorAusdruck_AST;
					currentAST.child = quantorAusdruck_AST!=null &&quantorAusdruck_AST.getFirstChild()!=null ?
						quantorAusdruck_AST.getFirstChild() : quantorAusdruck_AST;
					currentAST.advanceChildToEnd();
				}
				quantorAusdruck_AST = (AST)currentAST.root;
				break;
			}
			case Zeichenkette:
			case Name:
			case Minus:
			case Nicht:
			case EckigeKlammerAuf:
			case GeschweifteKlammerAuf:
			case Zahl:
			case Aktuell:
			case Undefiniert:
			case KlammerAuf:
			case Falsch:
			case Wahr:
			{
				oderAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				quantorAusdruck_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = quantorAusdruck_AST;
	}
	
	public final void fuer() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST fuer_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Fuer:
			{
				AST tmp59_AST = null;
				tmp59_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp59_AST);
				match(Fuer);
				fuer_AST = (AST)currentAST.root;
				break;
			}
			case Fuer2:
			{
				AST tmp60_AST = null;
				tmp60_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp60_AST);
				match(Fuer2);
				fuer_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_12);
			} else {
			  throw ex;
			}
		}
		returnAST = fuer_AST;
	}
	
	public final void quantor() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST quantor_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Alle:
			case Jede:
			case Jedes:
			case Jeden:
			{
				alle();
				astFactory.addASTChild(currentAST, returnAST);
				quantor_AST = (AST)currentAST.root;
				break;
			}
			case Ein:
			case Einen:
			case Eine:
			{
				ein();
				astFactory.addASTChild(currentAST, returnAST);
				quantor_AST = (AST)currentAST.root;
				break;
			}
			case Mindestens:
			{
				AST tmp61_AST = null;
				tmp61_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp61_AST);
				match(Mindestens);
				anteil();
				astFactory.addASTChild(currentAST, returnAST);
				quantor_AST = (AST)currentAST.root;
				break;
			}
			case Hoechstens:
			{
				AST tmp62_AST = null;
				tmp62_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp62_AST);
				match(Hoechstens);
				anteil();
				astFactory.addASTChild(currentAST, returnAST);
				quantor_AST = (AST)currentAST.root;
				break;
			}
			case Hoechstens2:
			{
				AST tmp63_AST = null;
				tmp63_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp63_AST);
				match(Hoechstens2);
				anteil();
				astFactory.addASTChild(currentAST, returnAST);
				quantor_AST = (AST)currentAST.root;
				break;
			}
			case Name:
			{
				AST tmp64_AST = null;
				tmp64_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp64_AST);
				match(Name);
				quantor_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_13);
			} else {
			  throw ex;
			}
		}
		returnAST = quantor_AST;
	}
	
	public final void dem() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST dem_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Der:
			{
				match(Der);
				dem_AST = (AST)currentAST.root;
				break;
			}
			case Dem:
			{
				match(Dem);
				dem_AST = (AST)currentAST.root;
				break;
			}
			case Den:
			{
				match(Den);
				dem_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		returnAST = dem_AST;
	}
	
	public final void bedingungsTeil() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST bedingungsTeil_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Die:
			case Bedingung:
			{
				{
				switch ( LA(1)) {
				case Die:
				{
					match(Die);
					break;
				}
				case Bedingung:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(Bedingung);
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				erfuellt();
				astFactory.addASTChild(currentAST, returnAST);
				{
				switch ( LA(1)) {
				case Ist:
				{
					match(Ist);
					break;
				}
				case ZeilenEnde:
				case Der:
				case Name:
				case Prozent:
				case Die:
				case Bedingung:
				case Gilt:
				case EckigeKlammerZu:
				case GeschweifteKlammerZu:
				case Komma:
				case KlammerZu:
				case Bis:
				case Schrittweite:
				case Dann:
				case Erfuellt:
				case Erfuellt2:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				bedingungsTeil_AST = (AST)currentAST.root;
				break;
			}
			case Gilt:
			{
				match(Gilt);
				quantorAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				bedingungsTeil_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = bedingungsTeil_AST;
	}
	
	public final void oderAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST oderAusdruck_AST = null;
		
		try {      // for error handling
			undAusdruck();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop29:
			do {
				if ((LA(1)==Oder)) {
					AST tmp72_AST = null;
					tmp72_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp72_AST);
					match(Oder);
					undAusdruck();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop29;
				}
				
			} while (true);
			}
			oderAusdruck_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = oderAusdruck_AST;
	}
	
	public final void alle() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST alle_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Jede:
			{
				match(Jede);
				if ( inputState.guessing==0 ) {
					alle_AST = (AST)currentAST.root;
					alle_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(ALLE,"ALLE")).add(alle_AST));
					currentAST.root = alle_AST;
					currentAST.child = alle_AST!=null &&alle_AST.getFirstChild()!=null ?
						alle_AST.getFirstChild() : alle_AST;
					currentAST.advanceChildToEnd();
				}
				alle_AST = (AST)currentAST.root;
				break;
			}
			case Jedes:
			{
				match(Jedes);
				if ( inputState.guessing==0 ) {
					alle_AST = (AST)currentAST.root;
					alle_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(ALLE,"ALLE")).add(alle_AST));
					currentAST.root = alle_AST;
					currentAST.child = alle_AST!=null &&alle_AST.getFirstChild()!=null ?
						alle_AST.getFirstChild() : alle_AST;
					currentAST.advanceChildToEnd();
				}
				alle_AST = (AST)currentAST.root;
				break;
			}
			case Jeden:
			{
				match(Jeden);
				if ( inputState.guessing==0 ) {
					alle_AST = (AST)currentAST.root;
					alle_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(ALLE,"ALLE")).add(alle_AST));
					currentAST.root = alle_AST;
					currentAST.child = alle_AST!=null &&alle_AST.getFirstChild()!=null ?
						alle_AST.getFirstChild() : alle_AST;
					currentAST.advanceChildToEnd();
				}
				alle_AST = (AST)currentAST.root;
				break;
			}
			case Alle:
			{
				match(Alle);
				if ( inputState.guessing==0 ) {
					alle_AST = (AST)currentAST.root;
					alle_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(ALLE,"ALLE")).add(alle_AST));
					currentAST.root = alle_AST;
					currentAST.child = alle_AST!=null &&alle_AST.getFirstChild()!=null ?
						alle_AST.getFirstChild() : alle_AST;
					currentAST.advanceChildToEnd();
				}
				alle_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_13);
			} else {
			  throw ex;
			}
		}
		returnAST = alle_AST;
	}
	
	public final void ein() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST ein_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Ein:
			{
				match(Ein);
				if ( inputState.guessing==0 ) {
					ein_AST = (AST)currentAST.root;
					ein_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(EIN,"EIN")).add(ein_AST));
					currentAST.root = ein_AST;
					currentAST.child = ein_AST!=null &&ein_AST.getFirstChild()!=null ?
						ein_AST.getFirstChild() : ein_AST;
					currentAST.advanceChildToEnd();
				}
				ein_AST = (AST)currentAST.root;
				break;
			}
			case Einen:
			{
				match(Einen);
				if ( inputState.guessing==0 ) {
					ein_AST = (AST)currentAST.root;
					ein_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(EIN,"EIN")).add(ein_AST));
					currentAST.root = ein_AST;
					currentAST.child = ein_AST!=null &&ein_AST.getFirstChild()!=null ?
						ein_AST.getFirstChild() : ein_AST;
					currentAST.advanceChildToEnd();
				}
				ein_AST = (AST)currentAST.root;
				break;
			}
			case Eine:
			{
				match(Eine);
				if ( inputState.guessing==0 ) {
					ein_AST = (AST)currentAST.root;
					ein_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(EIN,"EIN")).add(ein_AST));
					currentAST.root = ein_AST;
					currentAST.child = ein_AST!=null &&ein_AST.getFirstChild()!=null ?
						ein_AST.getFirstChild() : ein_AST;
					currentAST.advanceChildToEnd();
				}
				ein_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_13);
			} else {
			  throw ex;
			}
		}
		returnAST = ein_AST;
	}
	
	public final void anteil() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anteil_AST = null;
		
		try {      // for error handling
			ausdruck();
			astFactory.addASTChild(currentAST, returnAST);
			{
			switch ( LA(1)) {
			case Prozent:
			{
				AST tmp80_AST = null;
				tmp80_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp80_AST);
				match(Prozent);
				break;
			}
			case Der:
			case Name:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			anteil_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_13);
			} else {
			  throw ex;
			}
		}
		returnAST = anteil_AST;
	}
	
	public final void erfuellt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST erfuellt_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Erfuellt:
			{
				match(Erfuellt);
				erfuellt_AST = (AST)currentAST.root;
				break;
			}
			case Erfuellt2:
			{
				match(Erfuellt2);
				erfuellt_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_14);
			} else {
			  throw ex;
			}
		}
		returnAST = erfuellt_AST;
	}
	
	public final void undAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST undAusdruck_AST = null;
		
		try {      // for error handling
			gleichheitsAusdruck();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop32:
			do {
				if ((LA(1)==Und)) {
					AST tmp83_AST = null;
					tmp83_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp83_AST);
					match(Und);
					gleichheitsAusdruck();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop32;
				}
				
			} while (true);
			}
			undAusdruck_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_15);
			} else {
			  throw ex;
			}
		}
		returnAST = undAusdruck_AST;
	}
	
	public final void gleichheitsAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST gleichheitsAusdruck_AST = null;
		
		try {      // for error handling
			vergleichsAusdruck();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop36:
			do {
				if ((LA(1)==Gleich||LA(1)==Ungleich)) {
					{
					switch ( LA(1)) {
					case Gleich:
					{
						AST tmp84_AST = null;
						tmp84_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp84_AST);
						match(Gleich);
						break;
					}
					case Ungleich:
					{
						AST tmp85_AST = null;
						tmp85_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp85_AST);
						match(Ungleich);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					vergleichsAusdruck();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop36;
				}
				
			} while (true);
			}
			gleichheitsAusdruck_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_16);
			} else {
			  throw ex;
			}
		}
		returnAST = gleichheitsAusdruck_AST;
	}
	
	public final void vergleichsAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST vergleichsAusdruck_AST = null;
		
		try {      // for error handling
			additionsAusdruck();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop40:
			do {
				if (((LA(1) >= Kleiner && LA(1) <= GroesserGleich))) {
					{
					switch ( LA(1)) {
					case Kleiner:
					{
						AST tmp86_AST = null;
						tmp86_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp86_AST);
						match(Kleiner);
						break;
					}
					case Groesser:
					{
						AST tmp87_AST = null;
						tmp87_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp87_AST);
						match(Groesser);
						break;
					}
					case KleinerGleich:
					{
						AST tmp88_AST = null;
						tmp88_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp88_AST);
						match(KleinerGleich);
						break;
					}
					case GroesserGleich:
					{
						AST tmp89_AST = null;
						tmp89_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp89_AST);
						match(GroesserGleich);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					additionsAusdruck();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop40;
				}
				
			} while (true);
			}
			vergleichsAusdruck_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_17);
			} else {
			  throw ex;
			}
		}
		returnAST = vergleichsAusdruck_AST;
	}
	
	public final void additionsAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST additionsAusdruck_AST = null;
		
		try {      // for error handling
			multiplikationsAusdruck();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop44:
			do {
				if (((LA(1) >= Plus && LA(1) <= Ampersand))) {
					{
					switch ( LA(1)) {
					case Plus:
					{
						AST tmp90_AST = null;
						tmp90_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp90_AST);
						match(Plus);
						break;
					}
					case Minus:
					{
						AST tmp91_AST = null;
						tmp91_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp91_AST);
						match(Minus);
						break;
					}
					case Ampersand:
					{
						AST tmp92_AST = null;
						tmp92_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp92_AST);
						match(Ampersand);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					multiplikationsAusdruck();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop44;
				}
				
			} while (true);
			}
			additionsAusdruck_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_18);
			} else {
			  throw ex;
			}
		}
		returnAST = additionsAusdruck_AST;
	}
	
	public final void multiplikationsAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST multiplikationsAusdruck_AST = null;
		
		try {      // for error handling
			negationsAusdruck();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop48:
			do {
				if (((LA(1) >= Mal && LA(1) <= Modulo))) {
					{
					switch ( LA(1)) {
					case Mal:
					{
						AST tmp93_AST = null;
						tmp93_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp93_AST);
						match(Mal);
						break;
					}
					case Dividiert:
					{
						AST tmp94_AST = null;
						tmp94_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp94_AST);
						match(Dividiert);
						break;
					}
					case Div:
					{
						AST tmp95_AST = null;
						tmp95_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp95_AST);
						match(Div);
						break;
					}
					case Modulo:
					{
						AST tmp96_AST = null;
						tmp96_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp96_AST);
						match(Modulo);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					negationsAusdruck();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop48;
				}
				
			} while (true);
			}
			multiplikationsAusdruck_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_19);
			} else {
			  throw ex;
			}
		}
		returnAST = multiplikationsAusdruck_AST;
	}
	
	public final void negationsAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST negationsAusdruck_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Minus:
			case Nicht:
			{
				{
				switch ( LA(1)) {
				case Minus:
				{
					AST tmp97_AST = null;
					tmp97_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp97_AST);
					match(Minus);
					break;
				}
				case Nicht:
				{
					AST tmp98_AST = null;
					tmp98_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp98_AST);
					match(Nicht);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				negationsAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				negationsAusdruck_AST = (AST)currentAST.root;
				break;
			}
			case Zeichenkette:
			case Name:
			case EckigeKlammerAuf:
			case GeschweifteKlammerAuf:
			case Zahl:
			case Aktuell:
			case Undefiniert:
			case KlammerAuf:
			case Falsch:
			case Wahr:
			{
				erweiterterAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				negationsAusdruck_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_11);
			} else {
			  throw ex;
			}
		}
		returnAST = negationsAusdruck_AST;
	}
	
	public final void basisAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST basisAusdruck_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Falsch:
			case Wahr:
			{
				wahrheitswert();
				astFactory.addASTChild(currentAST, returnAST);
				basisAusdruck_AST = (AST)currentAST.root;
				break;
			}
			case Zeichenkette:
			{
				AST tmp99_AST = null;
				tmp99_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp99_AST);
				match(Zeichenkette);
				basisAusdruck_AST = (AST)currentAST.root;
				break;
			}
			case Aktuell:
			{
				AST tmp100_AST = null;
				tmp100_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp100_AST);
				match(Aktuell);
				basisAusdruck_AST = (AST)currentAST.root;
				break;
			}
			case Undefiniert:
			{
				AST tmp101_AST = null;
				tmp101_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp101_AST);
				match(Undefiniert);
				basisAusdruck_AST = (AST)currentAST.root;
				break;
			}
			default:
				if ((LA(1)==Zahl) && (_tokenSet_11.member(LA(2)))) {
					AST tmp102_AST = null;
					tmp102_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp102_AST);
					match(Zahl);
					basisAusdruck_AST = (AST)currentAST.root;
				}
				else if ((LA(1)==Zahl) && ((LA(2) >= Millisekunden && LA(2) <= Tag))) {
					zeitAngabe();
					astFactory.addASTChild(currentAST, returnAST);
					basisAusdruck_AST = (AST)currentAST.root;
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_11);
			} else {
			  throw ex;
			}
		}
		returnAST = basisAusdruck_AST;
	}
	
	public final void erweiterbarerBasisAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST erweiterbarerBasisAusdruck_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case KlammerAuf:
			{
				match(KlammerAuf);
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				match(KlammerZu);
				erweiterbarerBasisAusdruck_AST = (AST)currentAST.root;
				break;
			}
			case EckigeKlammerAuf:
			{
				feldKonstruktorAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				erweiterbarerBasisAusdruck_AST = (AST)currentAST.root;
				break;
			}
			case GeschweifteKlammerAuf:
			{
				listenKonstruktorAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				erweiterbarerBasisAusdruck_AST = (AST)currentAST.root;
				break;
			}
			default:
				if ((LA(1)==Name) && (_tokenSet_20.member(LA(2)))) {
					AST tmp105_AST = null;
					tmp105_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp105_AST);
					match(Name);
					erweiterbarerBasisAusdruck_AST = (AST)currentAST.root;
				}
				else if ((LA(1)==Name) && (LA(2)==KlammerAuf)) {
					funktionsAufruf();
					astFactory.addASTChild(currentAST, returnAST);
					erweiterbarerBasisAusdruck_AST = (AST)currentAST.root;
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = erweiterbarerBasisAusdruck_AST;
	}
	
	public final void attributOderMethodenaufruf() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST attributOderMethodenaufruf_AST = null;
		
		try {      // for error handling
			if ((LA(1)==Name) && (_tokenSet_20.member(LA(2)))) {
				AST tmp106_AST = null;
				tmp106_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp106_AST);
				match(Name);
				attributOderMethodenaufruf_AST = (AST)currentAST.root;
			}
			else if ((LA(1)==Name) && (LA(2)==KlammerAuf)) {
				AST tmp107_AST = null;
				tmp107_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp107_AST);
				match(Name);
				{
				match(KlammerAuf);
				{
				switch ( LA(1)) {
				case Zeichenkette:
				case Name:
				case Minus:
				case Nicht:
				case EckigeKlammerAuf:
				case GeschweifteKlammerAuf:
				case Zahl:
				case Aktuell:
				case Undefiniert:
				case KlammerAuf:
				case Fuer:
				case Fuer2:
				case Falsch:
				case Wahr:
				{
					aktuellerParameter();
					astFactory.addASTChild(currentAST, returnAST);
					{
					_loop76:
					do {
						if ((LA(1)==Komma)) {
							match(Komma);
							aktuellerParameter();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else {
							break _loop76;
						}
						
					} while (true);
					}
					break;
				}
				case KlammerZu:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(KlammerZu);
				}
				if ( inputState.guessing==0 ) {
					attributOderMethodenaufruf_AST = (AST)currentAST.root;
					attributOderMethodenaufruf_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(FUNKTIONSAUFRUF,"FUNKTIONSAUFRUF")).add(attributOderMethodenaufruf_AST));
					currentAST.root = attributOderMethodenaufruf_AST;
					currentAST.child = attributOderMethodenaufruf_AST!=null &&attributOderMethodenaufruf_AST.getFirstChild()!=null ?
						attributOderMethodenaufruf_AST.getFirstChild() : attributOderMethodenaufruf_AST;
					currentAST.advanceChildToEnd();
				}
				attributOderMethodenaufruf_AST = (AST)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = attributOderMethodenaufruf_AST;
	}
	
	public final void selektorAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST selektorAusdruck_AST = null;
		
		try {      // for error handling
			AST tmp111_AST = null;
			tmp111_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp111_AST);
			match(Name);
			match(Doppelpunkt);
			ausdruck();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop57:
			do {
				if ((LA(1)==Komma)) {
					match(Komma);
					AST tmp114_AST = null;
					tmp114_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp114_AST);
					match(Name);
					match(Doppelpunkt);
					ausdruck();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop57;
				}
				
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				selektorAusdruck_AST = (AST)currentAST.root;
				selektorAusdruck_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(SELEKTOR,"SELEKTOR")).add(selektorAusdruck_AST));
				currentAST.root = selektorAusdruck_AST;
				currentAST.child = selektorAusdruck_AST!=null &&selektorAusdruck_AST.getFirstChild()!=null ?
					selektorAusdruck_AST.getFirstChild() : selektorAusdruck_AST;
				currentAST.advanceChildToEnd();
			}
			selektorAusdruck_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_21);
			} else {
			  throw ex;
			}
		}
		returnAST = selektorAusdruck_AST;
	}
	
	public final void zeitAngabe() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST zeitAngabe_AST = null;
		
		try {      // for error handling
			{
			int _cnt149=0;
			_loop149:
			do {
				if ((LA(1)==Zahl)) {
					AST tmp116_AST = null;
					tmp116_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp116_AST);
					match(Zahl);
					zeitEinheiten();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					if ( _cnt149>=1 ) { break _loop149; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt149++;
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				zeitAngabe_AST = (AST)currentAST.root;
				zeitAngabe_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(ZEIT,"ZEIT")).add(zeitAngabe_AST));
				currentAST.root = zeitAngabe_AST;
				currentAST.child = zeitAngabe_AST!=null &&zeitAngabe_AST.getFirstChild()!=null ?
					zeitAngabe_AST.getFirstChild() : zeitAngabe_AST;
				currentAST.advanceChildToEnd();
			}
			zeitAngabe_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_11);
			} else {
			  throw ex;
			}
		}
		returnAST = zeitAngabe_AST;
	}
	
	public final void wahrheitswert() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST wahrheitswert_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Falsch:
			{
				AST tmp117_AST = null;
				tmp117_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp117_AST);
				match(Falsch);
				wahrheitswert_AST = (AST)currentAST.root;
				break;
			}
			case Wahr:
			{
				AST tmp118_AST = null;
				tmp118_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp118_AST);
				match(Wahr);
				wahrheitswert_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_11);
			} else {
			  throw ex;
			}
		}
		returnAST = wahrheitswert_AST;
	}
	
	public final void funktionsAufruf() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST funktionsAufruf_AST = null;
		
		try {      // for error handling
			AST tmp119_AST = null;
			tmp119_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp119_AST);
			match(Name);
			match(KlammerAuf);
			{
			switch ( LA(1)) {
			case Zeichenkette:
			case Name:
			case Minus:
			case Nicht:
			case EckigeKlammerAuf:
			case GeschweifteKlammerAuf:
			case Zahl:
			case Aktuell:
			case Undefiniert:
			case KlammerAuf:
			case Fuer:
			case Fuer2:
			case Falsch:
			case Wahr:
			{
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop71:
				do {
					if ((LA(1)==Komma)) {
						match(Komma);
						ausdruck();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop71;
					}
					
				} while (true);
				}
				break;
			}
			case KlammerZu:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(KlammerZu);
			if ( inputState.guessing==0 ) {
				funktionsAufruf_AST = (AST)currentAST.root;
				funktionsAufruf_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(FUNKTIONSAUFRUF,"FUNKTIONSAUFRUF")).add(funktionsAufruf_AST));
				currentAST.root = funktionsAufruf_AST;
				currentAST.child = funktionsAufruf_AST!=null &&funktionsAufruf_AST.getFirstChild()!=null ?
					funktionsAufruf_AST.getFirstChild() : funktionsAufruf_AST;
				currentAST.advanceChildToEnd();
			}
			funktionsAufruf_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = funktionsAufruf_AST;
	}
	
	public final void feldKonstruktorAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST feldKonstruktorAusdruck_AST = null;
		
		try {      // for error handling
			match(EckigeKlammerAuf);
			{
			switch ( LA(1)) {
			case Zeichenkette:
			case Name:
			case Minus:
			case Nicht:
			case EckigeKlammerAuf:
			case GeschweifteKlammerAuf:
			case Zahl:
			case Aktuell:
			case Undefiniert:
			case KlammerAuf:
			case Fuer:
			case Fuer2:
			case Falsch:
			case Wahr:
			{
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop63:
				do {
					if ((LA(1)==Komma)) {
						match(Komma);
						ausdruck();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop63;
					}
					
				} while (true);
				}
				break;
			}
			case EckigeKlammerZu:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(EckigeKlammerZu);
			if ( inputState.guessing==0 ) {
				feldKonstruktorAusdruck_AST = (AST)currentAST.root;
				feldKonstruktorAusdruck_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(FELD,"FELD")).add(feldKonstruktorAusdruck_AST));
				currentAST.root = feldKonstruktorAusdruck_AST;
				currentAST.child = feldKonstruktorAusdruck_AST!=null &&feldKonstruktorAusdruck_AST.getFirstChild()!=null ?
					feldKonstruktorAusdruck_AST.getFirstChild() : feldKonstruktorAusdruck_AST;
				currentAST.advanceChildToEnd();
			}
			feldKonstruktorAusdruck_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = feldKonstruktorAusdruck_AST;
	}
	
	public final void listenKonstruktorAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST listenKonstruktorAusdruck_AST = null;
		
		try {      // for error handling
			match(GeschweifteKlammerAuf);
			{
			switch ( LA(1)) {
			case Zeichenkette:
			case Name:
			case Minus:
			case Nicht:
			case EckigeKlammerAuf:
			case GeschweifteKlammerAuf:
			case Zahl:
			case Aktuell:
			case Undefiniert:
			case KlammerAuf:
			case Fuer:
			case Fuer2:
			case Falsch:
			case Wahr:
			{
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop67:
				do {
					if ((LA(1)==Komma)) {
						match(Komma);
						ausdruck();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop67;
					}
					
				} while (true);
				}
				break;
			}
			case GeschweifteKlammerZu:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(GeschweifteKlammerZu);
			if ( inputState.guessing==0 ) {
				listenKonstruktorAusdruck_AST = (AST)currentAST.root;
				listenKonstruktorAusdruck_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(LISTE,"LISTE")).add(listenKonstruktorAusdruck_AST));
				currentAST.root = listenKonstruktorAusdruck_AST;
				currentAST.child = listenKonstruktorAusdruck_AST!=null &&listenKonstruktorAusdruck_AST.getFirstChild()!=null ?
					listenKonstruktorAusdruck_AST.getFirstChild() : listenKonstruktorAusdruck_AST;
				currentAST.advanceChildToEnd();
			}
			listenKonstruktorAusdruck_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = listenKonstruktorAusdruck_AST;
	}
	
	public final void aktuellerParameter() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST aktuellerParameter_AST = null;
		
		try {      // for error handling
			if ((LA(1)==Name) && (LA(2)==Doppelpunkt)) {
				AST tmp129_AST = null;
				tmp129_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp129_AST);
				match(Name);
				AST tmp130_AST = null;
				tmp130_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp130_AST);
				match(Doppelpunkt);
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				aktuellerParameter_AST = (AST)currentAST.root;
			}
			else if ((_tokenSet_8.member(LA(1))) && (_tokenSet_22.member(LA(2)))) {
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				aktuellerParameter_AST = (AST)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_23);
			} else {
			  throw ex;
			}
		}
		returnAST = aktuellerParameter_AST;
	}
	
	public final void linksSeitigerBasisAusdruck() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST linksSeitigerBasisAusdruck_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Name:
			{
				AST tmp131_AST = null;
				tmp131_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp131_AST);
				match(Name);
				linksSeitigerBasisAusdruck_AST = (AST)currentAST.root;
				break;
			}
			case KlammerAuf:
			{
				match(KlammerAuf);
				linksSeitigerAusdruck();
				astFactory.addASTChild(currentAST, returnAST);
				match(KlammerZu);
				linksSeitigerBasisAusdruck_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_24);
			} else {
			  throw ex;
			}
		}
		returnAST = linksSeitigerBasisAusdruck_AST;
	}
	
	public final void fehlerBehandlungsBlock() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST fehlerBehandlungsBlock_AST = null;
		
		try {      // for error handling
			AST tmp134_AST = null;
			tmp134_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp134_AST);
			match(Fehlerbehandlung);
			AST tmp135_AST = null;
			tmp135_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp135_AST);
			match(Name);
			match(ZeilenEnde);
			anweisungsZeilen();
			astFactory.addASTChild(currentAST, returnAST);
			fehlerBehandlungsBlock_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_25);
			} else {
			  throw ex;
			}
		}
		returnAST = fehlerBehandlungsBlock_AST;
	}
	
	public final void iterationsKopf() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST iterationsKopf_AST = null;
		
		try {      // for error handling
			if ((LA(1)==Ueber||LA(1)==Ueber2) && (LA(2)==Name) && (LA(3)==In)) {
				mengenIteration();
				astFactory.addASTChild(currentAST, returnAST);
				iterationsKopf_AST = (AST)currentAST.root;
			}
			else if ((LA(1)==Ueber||LA(1)==Ueber2) && (LA(2)==Name) && (LA(3)==Von)) {
				laufIteration();
				astFactory.addASTChild(currentAST, returnAST);
				iterationsKopf_AST = (AST)currentAST.root;
			}
			else if ((LA(1)==Solange)) {
				AST tmp137_AST = null;
				tmp137_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp137_AST);
				match(Solange);
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				iterationsKopf_AST = (AST)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = iterationsKopf_AST;
	}
	
	public final void mengenIteration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST mengenIteration_AST = null;
		
		try {      // for error handling
			ueber();
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp138_AST = null;
			tmp138_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp138_AST);
			match(Name);
			match(In);
			ausdruck();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				mengenIteration_AST = (AST)currentAST.root;
				mengenIteration_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(MENGENITERATOR,"MENGENITERATOR")).add(mengenIteration_AST));
				currentAST.root = mengenIteration_AST;
				currentAST.child = mengenIteration_AST!=null &&mengenIteration_AST.getFirstChild()!=null ?
					mengenIteration_AST.getFirstChild() : mengenIteration_AST;
				currentAST.advanceChildToEnd();
			}
			mengenIteration_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = mengenIteration_AST;
	}
	
	public final void laufIteration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST laufIteration_AST = null;
		
		try {      // for error handling
			ueber();
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp140_AST = null;
			tmp140_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp140_AST);
			match(Name);
			match(Von);
			ausdruck();
			astFactory.addASTChild(currentAST, returnAST);
			match(Bis);
			ausdruck();
			astFactory.addASTChild(currentAST, returnAST);
			{
			switch ( LA(1)) {
			case Schrittweite:
			{
				match(Schrittweite);
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case ZeilenEnde:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				laufIteration_AST = (AST)currentAST.root;
				laufIteration_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(LAUFITERATOR,"LAUFITERATOR")).add(laufIteration_AST));
				currentAST.root = laufIteration_AST;
				currentAST.child = laufIteration_AST!=null &&laufIteration_AST.getFirstChild()!=null ?
					laufIteration_AST.getFirstChild() : laufIteration_AST;
				currentAST.advanceChildToEnd();
			}
			laufIteration_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = laufIteration_AST;
	}
	
	public final void ueber() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST ueber_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Ueber:
			{
				match(Ueber);
				ueber_AST = (AST)currentAST.root;
				break;
			}
			case Ueber2:
			{
				match(Ueber2);
				ueber_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_26);
			} else {
			  throw ex;
			}
		}
		returnAST = ueber_AST;
	}
	
	public final void zyklischKopf() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST zyklischKopf_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case Name:
			{
				AST tmp146_AST = null;
				tmp146_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp146_AST);
				match(Name);
				break;
			}
			case Alle:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(Alle);
			zeitAngabe();
			astFactory.addASTChild(currentAST, returnAST);
			match(ZeilenEnde);
			zyklischKopf_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_27);
			} else {
			  throw ex;
			}
		}
		returnAST = zyklischKopf_AST;
	}
	
	public final void wennAnweisungsDannTeil() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST wennAnweisungsDannTeil_AST = null;
		
		try {      // for error handling
			AST tmp149_AST = null;
			tmp149_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp149_AST);
			match(Dann);
			match(ZeilenEnde);
			anweisungsZeilen();
			astFactory.addASTChild(currentAST, returnAST);
			wennAnweisungsDannTeil_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_28);
			} else {
			  throw ex;
			}
		}
		returnAST = wennAnweisungsDannTeil_AST;
	}
	
	public final void wennAnweisungsAlternativen() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST wennAnweisungsAlternativen_AST = null;
		
		try {      // for error handling
			boolean synPredMatched100 = false;
			if (((LA(1)==Sonst) && (LA(2)==Wenn) && (_tokenSet_8.member(LA(3))))) {
				int _m100 = mark();
				synPredMatched100 = true;
				inputState.guessing++;
				try {
					{
					match(Sonst);
					match(Wenn);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched100 = false;
				}
				rewind(_m100);
inputState.guessing--;
			}
			if ( synPredMatched100 ) {
				wennAnweisungsAlternative();
				astFactory.addASTChild(currentAST, returnAST);
				wennAnweisungsAlternativen();
				astFactory.addASTChild(currentAST, returnAST);
				wennAnweisungsAlternativen_AST = (AST)currentAST.root;
			}
			else if ((LA(1)==Ende||LA(1)==Sonst) && (LA(2)==ZeilenEnde||LA(2)==Wenn) && (_tokenSet_27.member(LA(3)))) {
				wennAnweisungsAlternativen_AST = (AST)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_28);
			} else {
			  throw ex;
			}
		}
		returnAST = wennAnweisungsAlternativen_AST;
	}
	
	public final void wennAnweisungsDefault() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST wennAnweisungsDefault_AST = null;
		
		try {      // for error handling
			AST tmp151_AST = null;
			tmp151_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp151_AST);
			match(Sonst);
			match(ZeilenEnde);
			anweisungsZeilen();
			astFactory.addASTChild(currentAST, returnAST);
			wennAnweisungsDefault_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_29);
			} else {
			  throw ex;
			}
		}
		returnAST = wennAnweisungsDefault_AST;
	}
	
	public final void wennAnweisungsKurzformDannTeil() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST wennAnweisungsKurzformDannTeil_AST = null;
		
		try {      // for error handling
			AST tmp153_AST = null;
			tmp153_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp153_AST);
			match(Dann);
			anweisung();
			astFactory.addASTChild(currentAST, returnAST);
			wennAnweisungsKurzformDannTeil_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = wennAnweisungsKurzformDannTeil_AST;
	}
	
	public final void wennAnweisungsAlternative() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST wennAnweisungsAlternative_AST = null;
		
		try {      // for error handling
			match(Sonst);
			AST tmp155_AST = null;
			tmp155_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp155_AST);
			match(Wenn);
			ausdruck();
			astFactory.addASTChild(currentAST, returnAST);
			wennAnweisungsDannTeil();
			astFactory.addASTChild(currentAST, returnAST);
			wennAnweisungsAlternative_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_28);
			} else {
			  throw ex;
			}
		}
		returnAST = wennAnweisungsAlternative_AST;
	}
	
	public final void anmeldungDefinition() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anmeldungDefinition_AST = null;
		
		try {      // for error handling
			AST tmp156_AST = null;
			tmp156_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp156_AST);
			match(Definition);
			match(ZeilenEnde);
			anweisungsZeilen();
			astFactory.addASTChild(currentAST, returnAST);
			anmeldungDefinition_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_30);
			} else {
			  throw ex;
			}
		}
		returnAST = anmeldungDefinition_AST;
	}
	
	public final void anmeldungQuelle() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anmeldungQuelle_AST = null;
		
		try {      // for error handling
			AST tmp158_AST = null;
			tmp158_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp158_AST);
			match(Quelle);
			{
			int _cnt119=0;
			_loop119:
			do {
				if ((LA(1)==ZeilenEnde)) {
					match(ZeilenEnde);
				}
				else {
					if ( _cnt119>=1 ) { break _loop119; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt119++;
			} while (true);
			}
			{
			_loop121:
			do {
				if ((_tokenSet_31.member(LA(1)))) {
					anmeldungsZeile();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop121;
				}
				
			} while (true);
			}
			anmeldungQuelle_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_32);
			} else {
			  throw ex;
			}
		}
		returnAST = anmeldungQuelle_AST;
	}
	
	public final void anmeldungSender() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anmeldungSender_AST = null;
		
		try {      // for error handling
			AST tmp160_AST = null;
			tmp160_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp160_AST);
			match(Sender);
			{
			int _cnt124=0;
			_loop124:
			do {
				if ((LA(1)==ZeilenEnde)) {
					match(ZeilenEnde);
				}
				else {
					if ( _cnt124>=1 ) { break _loop124; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt124++;
			} while (true);
			}
			{
			_loop126:
			do {
				if ((_tokenSet_31.member(LA(1)))) {
					anmeldungsZeile();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop126;
				}
				
			} while (true);
			}
			anmeldungSender_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_33);
			} else {
			  throw ex;
			}
		}
		returnAST = anmeldungSender_AST;
	}
	
	public final void anmeldungSenke() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anmeldungSenke_AST = null;
		
		try {      // for error handling
			AST tmp162_AST = null;
			tmp162_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp162_AST);
			match(Senke);
			{
			int _cnt129=0;
			_loop129:
			do {
				if ((LA(1)==ZeilenEnde)) {
					match(ZeilenEnde);
				}
				else {
					if ( _cnt129>=1 ) { break _loop129; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt129++;
			} while (true);
			}
			{
			_loop131:
			do {
				if ((_tokenSet_31.member(LA(1)))) {
					anmeldungsZeile();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop131;
				}
				
			} while (true);
			}
			anmeldungSenke_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_34);
			} else {
			  throw ex;
			}
		}
		returnAST = anmeldungSenke_AST;
	}
	
	public final void anmeldungEmpfaenger() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anmeldungEmpfaenger_AST = null;
		
		try {      // for error handling
			empfaenger();
			astFactory.addASTChild(currentAST, returnAST);
			{
			int _cnt134=0;
			_loop134:
			do {
				if ((LA(1)==ZeilenEnde)) {
					match(ZeilenEnde);
				}
				else {
					if ( _cnt134>=1 ) { break _loop134; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt134++;
			} while (true);
			}
			{
			_loop136:
			do {
				if ((_tokenSet_31.member(LA(1)))) {
					anmeldungsZeile();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop136;
				}
				
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				anmeldungEmpfaenger_AST = (AST)currentAST.root;
				anmeldungEmpfaenger_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(EMPFAENGER,"EMPFAENGER")).add(anmeldungEmpfaenger_AST));
				currentAST.root = anmeldungEmpfaenger_AST;
				currentAST.child = anmeldungEmpfaenger_AST!=null &&anmeldungEmpfaenger_AST.getFirstChild()!=null ?
					anmeldungEmpfaenger_AST.getFirstChild() : anmeldungEmpfaenger_AST;
				currentAST.advanceChildToEnd();
			}
			anmeldungEmpfaenger_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_35);
			} else {
			  throw ex;
			}
		}
		returnAST = anmeldungEmpfaenger_AST;
	}
	
	public final void anmeldungInitial() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anmeldungInitial_AST = null;
		
		try {      // for error handling
			AST tmp165_AST = null;
			tmp165_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp165_AST);
			match(Initial);
			match(ZeilenEnde);
			anweisungsZeilen();
			astFactory.addASTChild(currentAST, returnAST);
			anmeldungInitial_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_36);
			} else {
			  throw ex;
			}
		}
		returnAST = anmeldungInitial_AST;
	}
	
	public final void anmeldungAktualisierung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anmeldungAktualisierung_AST = null;
		
		try {      // for error handling
			match(Jeweils);
			match(Bei);
			AST tmp169_AST = null;
			tmp169_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp169_AST);
			match(Aktualisierung);
			AST tmp170_AST = null;
			tmp170_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp170_AST);
			match(Name);
			match(ZeilenEnde);
			anweisungsZeilen();
			astFactory.addASTChild(currentAST, returnAST);
			anmeldungAktualisierung_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_36);
			} else {
			  throw ex;
			}
		}
		returnAST = anmeldungAktualisierung_AST;
	}
	
	public final void anmeldungMengenAenderung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anmeldungMengenAenderung_AST = null;
		
		try {      // for error handling
			match(Jeweils);
			match(Bei);
			mengenAenderung();
			AST tmp174_AST = null;
			tmp174_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp174_AST);
			match(Name);
			match(ZeilenEnde);
			anweisungsZeilen();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				anmeldungMengenAenderung_AST = (AST)currentAST.root;
				anmeldungMengenAenderung_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(MENGENAENDERUNG,"MENGENAENDERUNG")).add(anmeldungMengenAenderung_AST));
				currentAST.root = anmeldungMengenAenderung_AST;
				currentAST.child = anmeldungMengenAenderung_AST!=null &&anmeldungMengenAenderung_AST.getFirstChild()!=null ?
					anmeldungMengenAenderung_AST.getFirstChild() : anmeldungMengenAenderung_AST;
				currentAST.advanceChildToEnd();
			}
			anmeldungMengenAenderung_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_29);
			} else {
			  throw ex;
			}
		}
		returnAST = anmeldungMengenAenderung_AST;
	}
	
	public final void anmeldungsZeile() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST anmeldungsZeile_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Zeichenkette:
			case Name:
			case Minus:
			case Nicht:
			case EckigeKlammerAuf:
			case GeschweifteKlammerAuf:
			case Zahl:
			case Aktuell:
			case Undefiniert:
			case KlammerAuf:
			case Fuer:
			case Fuer2:
			case Falsch:
			case Wahr:
			{
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				match(Komma);
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				match(Komma);
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				{
				switch ( LA(1)) {
				case Komma:
				{
					match(Komma);
					match(Timer);
					zeitAngabe();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case ZeilenEnde:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				{
				int _cnt144=0;
				_loop144:
				do {
					if ((LA(1)==ZeilenEnde)) {
						match(ZeilenEnde);
					}
					else {
						if ( _cnt144>=1 ) { break _loop144; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					
					_cnt144++;
				} while (true);
				}
				if ( inputState.guessing==0 ) {
					anmeldungsZeile_AST = (AST)currentAST.root;
					anmeldungsZeile_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(ATGANMELDUNG,"ATGANMELDUNG")).add(anmeldungsZeile_AST));
					currentAST.root = anmeldungsZeile_AST;
					currentAST.child = anmeldungsZeile_AST!=null &&anmeldungsZeile_AST.getFirstChild()!=null ?
						anmeldungsZeile_AST.getFirstChild() : anmeldungsZeile_AST;
					currentAST.advanceChildToEnd();
				}
				anmeldungsZeile_AST = (AST)currentAST.root;
				break;
			}
			case Als:
			{
				match(Als);
				match(Menge);
				ausdruck();
				astFactory.addASTChild(currentAST, returnAST);
				{
				int _cnt146=0;
				_loop146:
				do {
					if ((LA(1)==ZeilenEnde)) {
						match(ZeilenEnde);
					}
					else {
						if ( _cnt146>=1 ) { break _loop146; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					
					_cnt146++;
				} while (true);
				}
				if ( inputState.guessing==0 ) {
					anmeldungsZeile_AST = (AST)currentAST.root;
					anmeldungsZeile_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(MENGENANMELDUNG,"MENGENANMELDUNG")).add(anmeldungsZeile_AST));
					currentAST.root = anmeldungsZeile_AST;
					currentAST.child = anmeldungsZeile_AST!=null &&anmeldungsZeile_AST.getFirstChild()!=null ?
						anmeldungsZeile_AST.getFirstChild() : anmeldungsZeile_AST;
					currentAST.advanceChildToEnd();
				}
				anmeldungsZeile_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_37);
			} else {
			  throw ex;
			}
		}
		returnAST = anmeldungsZeile_AST;
	}
	
	public final void empfaenger() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST empfaenger_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Empfaenger:
			{
				match(Empfaenger);
				empfaenger_AST = (AST)currentAST.root;
				break;
			}
			case Empfaenger2:
			{
				match(Empfaenger2);
				empfaenger_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = empfaenger_AST;
	}
	
	public final void mengenAenderung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST mengenAenderung_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case MengenAenderung:
			{
				AST tmp186_AST = null;
				tmp186_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp186_AST);
				match(MengenAenderung);
				mengenAenderung_AST = (AST)currentAST.root;
				break;
			}
			case MengenAenderung2:
			{
				AST tmp187_AST = null;
				tmp187_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp187_AST);
				match(MengenAenderung2);
				mengenAenderung_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_26);
			} else {
			  throw ex;
			}
		}
		returnAST = mengenAenderung_AST;
	}
	
	public final void zeitEinheiten() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST zeitEinheiten_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Millisekunden:
			{
				AST tmp188_AST = null;
				tmp188_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp188_AST);
				match(Millisekunden);
				zeitEinheiten_AST = (AST)currentAST.root;
				break;
			}
			case Sekunden:
			{
				AST tmp189_AST = null;
				tmp189_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp189_AST);
				match(Sekunden);
				zeitEinheiten_AST = (AST)currentAST.root;
				break;
			}
			case Minuten:
			{
				AST tmp190_AST = null;
				tmp190_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp190_AST);
				match(Minuten);
				zeitEinheiten_AST = (AST)currentAST.root;
				break;
			}
			case Stunden:
			{
				AST tmp191_AST = null;
				tmp191_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp191_AST);
				match(Stunden);
				zeitEinheiten_AST = (AST)currentAST.root;
				break;
			}
			case Tage:
			{
				AST tmp192_AST = null;
				tmp192_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp192_AST);
				match(Tage);
				zeitEinheiten_AST = (AST)currentAST.root;
				break;
			}
			case Millisekunde:
			{
				AST tmp193_AST = null;
				tmp193_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp193_AST);
				match(Millisekunde);
				zeitEinheiten_AST = (AST)currentAST.root;
				break;
			}
			case Sekunde:
			{
				AST tmp194_AST = null;
				tmp194_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp194_AST);
				match(Sekunde);
				zeitEinheiten_AST = (AST)currentAST.root;
				break;
			}
			case Minute:
			{
				AST tmp195_AST = null;
				tmp195_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp195_AST);
				match(Minute);
				zeitEinheiten_AST = (AST)currentAST.root;
				break;
			}
			case Stunde:
			{
				AST tmp196_AST = null;
				tmp196_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp196_AST);
				match(Stunde);
				zeitEinheiten_AST = (AST)currentAST.root;
				break;
			}
			case Tag:
			{
				AST tmp197_AST = null;
				tmp197_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp197_AST);
				match(Tag);
				zeitEinheiten_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_38);
			} else {
			  throw ex;
			}
		}
		returnAST = zeitEinheiten_AST;
	}
	
	public final void funktionsDefinition() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST funktionsDefinition_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Funktion:
			{
				AST tmp198_AST = null;
				tmp198_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp198_AST);
				match(Funktion);
				funktionsKopf();
				astFactory.addASTChild(currentAST, returnAST);
				match(ZeilenEnde);
				anweisungsZeilen();
				astFactory.addASTChild(currentAST, returnAST);
				match(Ende);
				match(Funktion);
				funktionsDefinition_AST = (AST)currentAST.root;
				break;
			}
			case Quantor:
			{
				AST tmp202_AST = null;
				tmp202_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp202_AST);
				match(Quantor);
				quantorKopf();
				astFactory.addASTChild(currentAST, returnAST);
				match(ZeilenEnde);
				anweisungsZeilen();
				astFactory.addASTChild(currentAST, returnAST);
				match(Ende);
				match(Quantor);
				funktionsDefinition_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = funktionsDefinition_AST;
	}
	
	public final void funktionsKopf() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST funktionsKopf_AST = null;
		
		try {      // for error handling
			AST tmp206_AST = null;
			tmp206_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp206_AST);
			match(Name);
			match(KlammerAuf);
			formaleParameter();
			astFactory.addASTChild(currentAST, returnAST);
			match(KlammerZu);
			funktionsKopf_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = funktionsKopf_AST;
	}
	
	public final void quantorKopf() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST quantorKopf_AST = null;
		
		try {      // for error handling
			AST tmp209_AST = null;
			tmp209_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp209_AST);
			match(Name);
			match(Der);
			match(Elemente);
			match(In);
			AST tmp213_AST = null;
			tmp213_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp213_AST);
			match(Name);
			match(Gilt);
			match(Bedingung);
			AST tmp216_AST = null;
			tmp216_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp216_AST);
			match(Name);
			quantorKopf_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = quantorKopf_AST;
	}
	
	public final void formaleParameter() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST formaleParameter_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case KlammerZu:
			{
				formaleParameter_AST = (AST)currentAST.root;
				break;
			}
			case Name:
			{
				AST tmp217_AST = null;
				tmp217_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp217_AST);
				match(Name);
				{
				_loop157:
				do {
					if ((LA(1)==Komma)) {
						match(Komma);
						AST tmp219_AST = null;
						tmp219_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp219_AST);
						match(Name);
					}
					else {
						break _loop157;
					}
					
				} while (true);
				}
				formaleParameter_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_39);
			} else {
			  throw ex;
			}
		}
		returnAST = formaleParameter_AST;
	}
	
	public final void fehlerpruefung() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST fehlerpruefung_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Fehlerpruefung:
			{
				AST tmp220_AST = null;
				tmp220_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp220_AST);
				match(Fehlerpruefung);
				fehlerpruefung_AST = (AST)currentAST.root;
				break;
			}
			case Fehlerpruefung2:
			{
				AST tmp221_AST = null;
				tmp221_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp221_AST);
				match(Fehlerpruefung2);
				fehlerpruefung_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_0);
			} else {
			  throw ex;
			}
		}
		returnAST = fehlerpruefung_AST;
	}
	
	public final void fehlerrueckgabe() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST fehlerrueckgabe_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Fehlerrueckgabe:
			{
				AST tmp222_AST = null;
				tmp222_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp222_AST);
				match(Fehlerrueckgabe);
				fehlerrueckgabe_AST = (AST)currentAST.root;
				break;
			}
			case Fehlerrueckgabe2:
			{
				AST tmp223_AST = null;
				tmp223_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp223_AST);
				match(Fehlerrueckgabe2);
				fehlerrueckgabe_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_0);
			} else {
			  throw ex;
			}
		}
		returnAST = fehlerrueckgabe_AST;
	}
	
	public final void hoechstens() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST hoechstens_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case Hoechstens:
			{
				AST tmp224_AST = null;
				tmp224_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp224_AST);
				match(Hoechstens);
				if ( inputState.guessing==0 ) {
					hoechstens_AST = (AST)currentAST.root;
					hoechstens_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(MAXIMAL,"MAXIMAL")).add(hoechstens_AST));
					currentAST.root = hoechstens_AST;
					currentAST.child = hoechstens_AST!=null &&hoechstens_AST.getFirstChild()!=null ?
						hoechstens_AST.getFirstChild() : hoechstens_AST;
					currentAST.advanceChildToEnd();
				}
				hoechstens_AST = (AST)currentAST.root;
				break;
			}
			case Hoechstens2:
			{
				AST tmp225_AST = null;
				tmp225_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp225_AST);
				match(Hoechstens2);
				if ( inputState.guessing==0 ) {
					hoechstens_AST = (AST)currentAST.root;
					hoechstens_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(MAXIMAL,"MAXIMAL")).add(hoechstens_AST));
					currentAST.root = hoechstens_AST;
					currentAST.child = hoechstens_AST!=null &&hoechstens_AST.getFirstChild()!=null ?
						hoechstens_AST.getFirstChild() : hoechstens_AST;
					currentAST.advanceChildToEnd();
				}
				hoechstens_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_0);
			} else {
			  throw ex;
			}
		}
		returnAST = hoechstens_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"ZEIT\"",
		"\"SELEKTOR\"",
		"\"FELD\"",
		"\"LISTE\"",
		"\"RUECKGABEANWEISUNG\"",
		"\"ZUWEISUNG\"",
		"\"MENGENITERATOR\"",
		"\"LAUFITERATOR\"",
		"\"QUANTOR\"",
		"\"ALLE\"",
		"\"EIN\"",
		"\"MAXIMAL\"",
		"\"FUNKTIONSAUFRUF\"",
		"\"EMPFAENGER\"",
		"\"MENGENAENDERUNG\"",
		"\"ATGANMELDUNG\"",
		"\"MENGENANMELDUNG\"",
		"\"ATTRIBUTZUGRIFF\"",
		"ZeilenEnde",
		"Ausgabe",
		"Debug",
		"Benutze",
		"Zeichenkette",
		"Ausnahme",
		"Gleich",
		"Mit",
		"Fehlerausgabe",
		"Fehlerrueckgabe",
		"Fehlerrueckgabe2",
		"Ohne",
		"Fehlerpruefung",
		"Fehlerpruefung2",
		"Der",
		"Elemente",
		"Name",
		"In",
		"Mindestens",
		"Hoechstens",
		"Hoechstens2",
		"Prozent",
		"Die",
		"Bedingung",
		"Ist",
		"Gilt",
		"Oder",
		"Und",
		"Ungleich",
		"Kleiner",
		"Groesser",
		"KleinerGleich",
		"GroesserGleich",
		"Plus",
		"Minus",
		"Ampersand",
		"Mal",
		"Dividiert",
		"Div",
		"Modulo",
		"Nicht",
		"Punkt",
		"EckigeKlammerAuf",
		"EckigeKlammerZu",
		"GeschweifteKlammerAuf",
		"GeschweifteKlammerZu",
		"Doppelpunkt",
		"Komma",
		"Zahl",
		"Aktuell",
		"Undefiniert",
		"KlammerAuf",
		"KlammerZu",
		"Versuche",
		"Ende",
		"Iteration",
		"Solange",
		"Von",
		"Bis",
		"Schrittweite",
		"Zyklisch",
		"Alle",
		"Wenn",
		"Dann",
		"Sonst",
		"Anmeldung",
		"Definition",
		"Quelle",
		"Sender",
		"Senke",
		"Fehlerbehandlung",
		"Initial",
		"Jeweils",
		"Bei",
		"Aktualisierung",
		"Timer",
		"Als",
		"Menge",
		"Millisekunden",
		"Sekunden",
		"Minuten",
		"Stunden",
		"Tage",
		"Millisekunde",
		"Sekunde",
		"Minute",
		"Stunde",
		"Tag",
		"Funktion",
		"Quantor",
		"Jede",
		"Jedes",
		"Jeden",
		"Dem",
		"Den",
		"Ein",
		"Einen",
		"Eine",
		"Empfaenger",
		"Empfaenger2",
		"Erfuellt",
		"Erfuellt2",
		"Fuer",
		"Fuer2",
		"MengenAenderung",
		"MengenAenderung2",
		"Rueckgabe",
		"Rueckgabe2",
		"Ueber",
		"Ueber2",
		"Falsch",
		"Wahr"
	};
	
	protected void buildTokenTypeASTClassMap() {
		tokenTypeToASTClassMap=null;
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 284201844738L, 216383890474154496L, 3L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 284201844738L, 211106242243072L, 3L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 284201844736L, 9710080L, 3L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 0L, 216172784231911424L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 4194304L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 284197650432L, 9710080L, 3L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 202653741088768L, 864691128457430058L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	private static final long[] mk_tokenSet_8() {
		long[] data = { 4683743887410331648L, 3458764513820541893L, 48L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
	private static final long[] mk_tokenSet_9() {
		long[] data = { -273503181864960L, 3523855533465928655L, 48L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
	private static final long[] mk_tokenSet_10() {
		long[] data = { 268435456L, 1024L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
	private static final long[] mk_tokenSet_11() {
		long[] data = { 4611607197460201472L, 864691128457430058L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_11 = new BitSet(mk_tokenSet_11());
	private static final long[] mk_tokenSet_12() {
		long[] data = { 7971459301376L, 65020719620685824L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_12 = new BitSet(mk_tokenSet_12());
	private static final long[] mk_tokenSet_13() {
		long[] data = { 343597383680L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_13 = new BitSet(mk_tokenSet_13());
	private static final long[] mk_tokenSet_14() {
		long[] data = { 273022485266432L, 864691128457430058L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_14 = new BitSet(mk_tokenSet_14());
	private static final long[] mk_tokenSet_15() {
		long[] data = { 484128717799424L, 864691128457430058L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_15 = new BitSet(mk_tokenSet_15());
	private static final long[] mk_tokenSet_16() {
		long[] data = { 1047078671220736L, 864691128457430058L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_16 = new BitSet(mk_tokenSet_16());
	private static final long[] mk_tokenSet_17() {
		long[] data = { 2172978846498816L, 864691128457430058L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_17 = new BitSet(mk_tokenSet_17());
	private static final long[] mk_tokenSet_18() {
		long[] data = { 35949976051777536L, 864691128457430058L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_18 = new BitSet(mk_tokenSet_18());
	private static final long[] mk_tokenSet_19() {
		long[] data = { 288151555184525312L, 864691128457430058L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_19 = new BitSet(mk_tokenSet_19());
	private static final long[] mk_tokenSet_20() {
		long[] data = { -4611764839394574336L, 864691128457430063L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_20 = new BitSet(mk_tokenSet_20());
	private static final long[] mk_tokenSet_21() {
		long[] data = { 0L, 10L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_21 = new BitSet(mk_tokenSet_21());
	private static final long[] mk_tokenSet_22() {
		long[] data = { -273503181864960L, 3523855533465929711L, 48L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_22 = new BitSet(mk_tokenSet_22());
	private static final long[] mk_tokenSet_23() {
		long[] data = { 0L, 1056L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_23 = new BitSet(mk_tokenSet_23());
	private static final long[] mk_tokenSet_24() {
		long[] data = { -9223372036586340352L, 1025L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_24 = new BitSet(mk_tokenSet_24());
	private static final long[] mk_tokenSet_25() {
		long[] data = { 0L, 1610616832L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_25 = new BitSet(mk_tokenSet_25());
	private static final long[] mk_tokenSet_26() {
		long[] data = { 274877906944L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_26 = new BitSet(mk_tokenSet_26());
	private static final long[] mk_tokenSet_27() {
		long[] data = { 284201844736L, 9714176L, 3L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_27 = new BitSet(mk_tokenSet_27());
	private static final long[] mk_tokenSet_28() {
		long[] data = { 0L, 4198400L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_28 = new BitSet(mk_tokenSet_28());
	private static final long[] mk_tokenSet_29() {
		long[] data = { 0L, 4096L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_29 = new BitSet(mk_tokenSet_29());
	private static final long[] mk_tokenSet_30() {
		long[] data = { 0L, 216172784227717120L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_30 = new BitSet(mk_tokenSet_30());
	private static final long[] mk_tokenSet_31() {
		long[] data = { 4683743887410331648L, 3458764531000411077L, 48L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_31 = new BitSet(mk_tokenSet_31());
	private static final long[] mk_tokenSet_32() {
		long[] data = { 0L, 216172784194162688L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_32 = new BitSet(mk_tokenSet_32());
	private static final long[] mk_tokenSet_33() {
		long[] data = { 0L, 216172784127053824L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_33 = new BitSet(mk_tokenSet_33());
	private static final long[] mk_tokenSet_34() {
		long[] data = { 0L, 216172783992836096L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_34 = new BitSet(mk_tokenSet_34());
	private static final long[] mk_tokenSet_35() {
		long[] data = { 0L, 1879052288L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_35 = new BitSet(mk_tokenSet_35());
	private static final long[] mk_tokenSet_36() {
		long[] data = { 0L, 1073745920L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_36 = new BitSet(mk_tokenSet_36());
	private static final long[] mk_tokenSet_37() {
		long[] data = { 4683743887410331648L, 3674937315194573765L, 48L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_37 = new BitSet(mk_tokenSet_37());
	private static final long[] mk_tokenSet_38() {
		long[] data = { 4611607197460201472L, 864691128457430122L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_38 = new BitSet(mk_tokenSet_38());
	private static final long[] mk_tokenSet_39() {
		long[] data = { 0L, 1024L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_39 = new BitSet(mk_tokenSet_39());
	
	}
