/*
 * Segment 6 Intelligente Bewertungsverfahren, SWE 6.3 Umfassende Datenanalyse
 * Copyright (C) 2007-2015 BitCtrl Systems GmbH
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.ibv.uda.uda.data;

/**
 * eine Antwort auf die Ausführung eines Kommandos zur Ausführung eines
 * Skriptlaufs.
 *
 * @author BitCtrl Systems GmbH, Peuker
 */
public class LaufKommandoAntwort {

	/**
	 * die Antwortkategorie.
	 */
	private final SkriptLaufKommando typ;

	/**
	 * ein Text zur Beschreibung der Antwort.
	 */
	private final String meldung;

	/**
	 * Konstruktor.
	 *
	 * @param typ
	 *            die Kategorie
	 * @param meldung
	 *            der beschreibende Text
	 */
	public LaufKommandoAntwort(final SkriptLaufKommando typ, final String meldung) {
		this.typ = typ;
		this.meldung = meldung;
	}

	/**
	 * liefert den beschreibenden Text.
	 *
	 * @return den Text
	 */
	public String getMeldung() {
		return meldung;
	}

	/**
	 * liefert die Kataegorie der Antwort.
	 *
	 * @return den Typ
	 */
	public SkriptLaufKommando getTyp() {
		return typ;
	}

	/**
	 * {@inheritDoc}.
	 *
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return typ.toString() + ": " + meldung;
	}
}
